#!/usr/bin/perl

use strict;

my @PKGS = qw(xconfig_more_keyboards.tgz cdrom_based_update_and_patch.tgz kernel_update.tgz);

my $redir = '';

my $root = $ENV{'FS_UPDATE_ROOT'};

sub install_single {
    my $file = shift;
    unless ($0 =~ /^(.*\/)/) {
    	print STDERR "ERROR: can't find script directory!\n";
    	return 1;
    }
    $file = $1 . $file;
    if ($file =~ /\.tgz$|\.tar\.gz$/i) {
        print         "cd ${root}/ ; tar xzf '$file' $redir\n";
        return system("cd ${root}/ ; tar xzf '$file' $redir");
    } elsif ($file =~ /\.tar.bz2$/i) {
        print         "cd ${root}/ ; bzcat '$file' | tar xf '-' $redir\n";
        return system("cd ${root}/ ; bzcat '$file' | tar xf '-' $redir");
    } elsif ($file =~ /\.zip$/i) {
        print         "cd ${root}/ ; unzip -o -q -L '$file' $redir\n";
        return system("cd ${root}/ ; unzip -o -q -L '$file' $redir");
    } elsif ($file =~ /\.deb$/i) {
        print         "cd ${root}/ ; dpkg -i '$file' $redir\n";
        return system("cd ${root}/ ; dpkg -i '$file' $redir");
    } elsif ($file =~ /\.diff$/i) {
        print         "cd ${root}/ ; patch -p0 '$file' $redir\n";
        return system("cd ${root}/ ; patch -p0 '$file' $redir");
    }
    print STDERR "ERROR: Unknown package format!\n";
    return 1;
}

sub install_pkgs {
	my $err = 0;
	for my $p (@PKGS) {
		print "Update $p\n";
		if (install_single($p)) {
			print STDERR "ERROR installing $p!\n";
			$err = 1;
		}
	}
	return $err;
}

exit install_pkgs();

